BrightSignCECIA.prototype = new EventEmitter();
BrightSignCECIA.prototype.constructor = BrightSignCECIA;

function BrightSignCECIA() {

	this.emit('MessageReceived', ["Constructor Begin"]);

	var self = this;
    setTimeout(function() {
         //initialize CEC receiver only on Brightsign platform
	try {
		var cec_in = new BSCECReceiver();

		self.emit('MessageReceived', ["CEC Receiver initialized"]);

		cec_in.oncecrxframe = function(e){
			console.log('############ oncecrxframe: ' + e.data);
			console.log("Decoded data: " + bin2String(e.data));
		 }

		cec_in.oncectxcomplete = function(e){
			console.log('############ oncecrxframe: ' + e.data);
			self.emit('MessageReceived', ["Status: "+e.status + " -- Data: "+ e.data]);
		}

		
	} catch (error) {
		console.log("BSCECReicever not available on this platform.")
		self.emit('MessageReceived', ["ERROR: "+error]);
	}
	
   }, 3000);

	
}


function bin2String(array) {
	var result = "";
	for (var i = 0; i < array.length; i++) {
	  result += String.fromCharCode(parseInt(array[i], 2));
	}
	return result;
  }


BrightSignCECIA.prototype.sendCECStringMessage = function (message) { 	
	var cec_control = new BSCECTransmitter();
	cec_control.SendRawMessage(message);
}

BrightSignCECIA.prototype.sendCECMessage = function (message) { 
	
	var typedArray = new Uint8Array(message.match(/[\da-f]{2}/gi).map(function (h) {
	  return parseInt(h, 16)
	}))	
	var buffer = typedArray.buffer

	var cec_control = new BSCECTransmitter();
	cec_control.SendRawMessage(buffer);
}


BrightSignCECIA.prototype.getCECVersion = function () { 
	console.log("### getCECVersion ###");
	var cec_control = new BSCECTransmitter();
	var buffer = new Uint8Array(2);
	buffer[ 0 ] = 0x40;
	buffer[ 1 ] = 0x9F; // "text View On"
	 //0x04 for "Image view on"
	cec_control.SendRawMessage(buffer);
};

BrightSignCECIA.prototype.turnDisplayOn = function () { 
	console.log("### cecDisplayOn ###");
	var cec_control = new BSCECTransmitter();
	var buffer = new Uint8Array(2);
	buffer[ 0 ] = 0x40;
	buffer[ 1 ] = 0x0D; // "text View On"
	 //0x04 for "Image view on"
	cec_control.SendRawMessage(buffer);
};


BrightSignCECIA.prototype.turnDisplayOff = function () { 
	console.log("### cecDisplayOff ###");
	var cec_control = new BSCECTransmitter();
	var buffer = new Uint8Array(2);
	buffer[ 0 ] = 0x40;
	buffer[ 1 ] = 0x36;
	cec_control.SendRawMessage(buffer);
};